## ros-kinetic-rr-openrover-driver 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(rr_openrover_driver)

add_compile_options(-std=c++11)
find_package(catkin REQUIRED COMPONENTS
  roscpp
  rospy
  std_msgs
  message_generation
  geometry_msgs
  nav_msgs
  tf2
  rr_openrover_driver_msgs
)

generate_messages(
   DEPENDENCIES
   std_msgs
   geometry_msgs
   nav_msgs
   rr_openrover_driver_msgs
)

catkin_package(
  INCLUDE_DIRS include
  CATKIN_DEPENDS message_runtime rr_openrover_driver_msgs
)

###########
## Build ##
###########

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

add_library(odom_control src/odom_control.cpp)

add_executable(openrover_driver_node src/openrover_driver.cpp)
add_dependencies(openrover_driver_node rr_openrover_driver_generate_messages_cpp ${catkin_EXPORTED_TARGETS})
target_link_libraries(openrover_driver_node ${catkin_LIBRARIES} odom_control)


#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS openrover_driver_node
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(TARGETS odom_control
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

## Copy launch files
install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
  FILES_MATCHING PATTERN "*.launch"
)

## Copy config files
install(DIRECTORY config/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/config
  FILES_MATCHING PATTERN "*.yaml"
)

install(DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
   FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp"
)

catkin_install_python(PROGRAMS scripts/diagnostics.py
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/
)

=== debian/changelog ===
ros-kinetic-rr-openrover-driver (1.0.1-1xenial) xenial; urgency=high



 -- Nick Padilla <nickpadilla@roverrobotics.com>  Mon, 15 Jun 2020 05:00:00 -0000

ros-kinetic-rr-openrover-driver (1.0.0-1xenial) xenial; urgency=high

  * Update teleop.launch
  * Contributors: Nick Fragale, padiln

 -- Nick Padilla <nickpadilla@roverrobotics.com>  Mon, 08 Jun 2020 05:00:00 -0000

ros-kinetic-rr-openrover-driver (0.8.0-1xenial) xenial; urgency=high



 -- Nick Padilla <nickpadilla@roverrobotics.com>  Wed, 25 Mar 2020 05:00:00 -0000

ros-kinetic-rr-openrover-driver (0.7.4-1xenial) xenial; urgency=high

  * changed maintainership of all packages to nick padilla
  * Hotfix, remove integral gain overwrite
  * fix variable setting error affecting PID
  * exposed PID gains as ros parameters
  * added autodocking launch file and descriptions
  * Adding description and 4WD code
  * The coefficient that scaled the flipper motor commands wasn't being initialized properly so the flipper motor commands sent to the robot were flicking all over the place with the smallest change in commanded velocity. Solution: initialize the motor speed coefficients in every wheel configuration.
  * fix rover message buffer race condition
  * Updating the openerrover_driver to clean up how rover data is published. The current state of the driver data read from the rover is categorized as fast, medium, and slow rate data. All data types for a given rate are published in the same message. This requires users to parse the topic message to find the field for the desired information in the message. This pull request eliminates the rate based messages and instead publishes odometry, battery_state_of_charge and separate topics. For backwards compatibility the boolean parameter "use_legacy" publishes the rate topics if set to true.
    Additionally, all uses of tf have been updated to use tf2.
  * Contributors: Jack Kilian, padiln

 -- Nick Padilla <nickpadilla@roverrobotics.com>  Wed, 19 Feb 2020 06:00:00 -0000

ros-kinetic-rr-openrover-driver (0.7.3-1xenial) xenial; urgency=high

  * Migrating all usage of tf to tf2
  * Simplified rover data messages and only publish rate-based data in legacy mode

 -- Jack Kilian <jack@digilabs.io>  Mon, 14 Oct 2019 05:00:00 -0000

ros-kinetic-rr-openrover-driver (0.7.2-1xenial) xenial; urgency=high

  * Changed name to rr_openrover_drive from rr_openrover_basic
  * Refactored openrover_driver to accept Twist msgs instead of TwistStamped msgs

 -- Jack Kilian <jack@digilabs.io>  Thu, 18 Jul 2019 05:00:00 -0000

ros-kinetic-rr-openrover-driver (0.7.1-1xenial) xenial; urgency=high

  * Changed default port to /dev/rover
  * Changed CMAke to install diagnostics.py

 -- Jack Kilian <jack@digilabs.io>  Mon, 24 Jun 2019 05:00:00 -0000

ros-kinetic-rr-openrover-driver (0.7.0-1xenial) xenial; urgency=high

  * Fixed issue #12
  * Added fan speed control
  * Added launch file for 2wd teleop
  * Changed default fast rate data to 10hz

 -- Jack Kilian <jack@digilabs.io>  Mon, 13 May 2019 05:00:00 -0000

ros-kinetic-rr-openrover-driver (0.6.2-1xenial) xenial; urgency=high

  * Fixed issue #13

 -- Jack Kilian <jack@digilabs.io>  Wed, 23 Jan 2019 06:00:00 -0000

ros-kinetic-rr-openrover-driver (0.6.1-1xenial) xenial; urgency=high

  * Migrated release repo from /roverrobotics to /roverrobotics-release
  * Changed rosparam slippage_factor to traction_factor
  * Changed default weight to 20.0 lbs
  * Changed default drive type to 4WD
  * Changed default closed_loop_control_on to false
  * Removed low_speed_mode

 -- Jack Kilian <jack@digilabs.io>  Thu, 13 Dec 2018 06:00:00 -0000

ros-kinetic-rr-openrover-driver (0.6.0-1xenial) xenial; urgency=high

  * Added ROS topic /rr_openrover_driver/battery_status_a
  * Added ROS topic /rr_openrover_driver/battery_status_b

 -- Jack Kilian <jack@digilabs.io>  Sat, 08 Dec 2018 06:00:00 -0000

ros-kinetic-rr-openrover-driver (0.5.1-1xenial) xenial; urgency=high

  * Added ROS topic /rr_openrover_driver/motor_speeds_commanded
  * Added ROS topic /rr_openrover_driver/charging
  * Fixed issue #8

 -- Jack Kilian <jack@digilabs.io>  Fri, 07 Dec 2018 06:00:00 -0000

ros-kinetic-rr-openrover-driver (0.5.0-1xenial) xenial; urgency=high

  * Added ROS param for 'odom covariances'
  * Added ROS param for 'slippage factor'
  * Added diagnostics node
  * Fixed issue #1

 -- Jack Kilian <jack@digilabs.io>  Fri, 07 Dec 2018 06:00:00 -0000

ros-kinetic-rr-openrover-driver (0.4.0-1xenial) xenial; urgency=high

  * Added ROS param 'drive_type'

 -- Jack Kilian <jack@digilabs.io>  Mon, 23 Jul 2018 05:00:00 -0000

ros-kinetic-rr-openrover-driver (0.3.0-1xenial) xenial; urgency=high

  * Added ROS topic /rr_openrover_driver/odom_encoder
  * Added 2nd maintainer to package.xml and URL to wiki

 -- Jack Kilian <jack@digilabs.io>  Thu, 19 Jul 2018 05:00:00 -0000

ros-kinetic-rr-openrover-driver (0.2.0-1xenial) xenial; urgency=high

  * Fixed low-speed mode turning so it has a continuous turning speed range
  * Added dependency to generate messages cpp to CMakeLists
  * updated package.xml to new format

 -- Jack Kilian <jack@digilabs.io>  Tue, 17 Jul 2018 05:00:00 -0000

ros-kinetic-rr-openrover-driver (0.1.0-1xenial) xenial; urgency=high

  * first public release for Kinetic

 -- Jack Kilian <jack@digilabs.io>  Tue, 10 Jul 2018 05:00:00 -0000

=== debian/control ===
Source: ros-kinetic-rr-openrover-driver
Section: misc
Priority: optional
Maintainer: Nick Padilla <nickpadilla@roverrobotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-catkin, ros-kinetic-geometry-msgs, ros-kinetic-message-generation, ros-kinetic-nav-msgs, ros-kinetic-roscpp, ros-kinetic-rospy, ros-kinetic-rr-openrover-driver-msgs, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf2, ros-kinetic-tf2-geometry-msgs
Homepage: http://ros.org/wiki/rr_openrover_driver
Standards-Version: 3.9.2

Package: ros-kinetic-rr-openrover-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-geometry-msgs, ros-kinetic-joy, ros-kinetic-message-runtime, ros-kinetic-nav-msgs, ros-kinetic-roscpp, ros-kinetic-rospy, ros-kinetic-rr-openrover-driver-msgs, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf2, ros-kinetic-twist-mux
Description: Provides an interface between ros and Rover Robotics rover hardware.
 Inputs to rr_openrover_driver include emergency stop and velocity commands. It outputs diagnostic data such as encoder readings and battery charge.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-rr-openrover-driver//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
